#include"small_functions.h"








// dummy matrix, generating X, used for test. Not used here
matrix<double> Get_X(){
	int N=5000, dim=10, sigma=1;
	double s1_2=290,s2_2=300,c1=-0.3,c2=-0.925;

	//int i;
	//generate a randome vector
	boost::numeric::ublas::vector<double> v(N);
	generate(v.begin(),v.end(),RandomNumber);// here calls struct ca

	matrix<double> u1(N,1);
	column(u1, 0) =sqrt(s1_2)*v;
	matrix<double> u2(N,1);
	column(u2, 0)=sqrt(s2_2)*v;
	matrix<double> u3(N,1);
	u3=c1*u1+c2*u2;

	matrix<double> Xraw1=bind(u1,u1,1);
	Xraw1=bind(Xraw1,Xraw1,1);

	matrix<double> Xraw2=bind(u2,u2,1);
	Xraw2=bind(Xraw2,Xraw2,1);

	matrix<double> Xraw3=bind(u3,u3,1);

	matrix<double> Xraw=bind(Xraw1,Xraw2,1);
	Xraw=bind(Xraw,Xraw3,1);

	matrix<double> R(N,dim);
	generate(R.data().begin(),R.data().end(),RandomNumber);

	matrix<double> X=Xraw+sigma*R;

	return X;
}



//The following use the above template to read in a big matrix from a file. Using C++ to read big matrix from a file, need the above code.
//The data will store in matrix<double> type

matrix<double> Get_X_Read(){
	cout<<"reading matrix X, might take a long time......"<<endl;
	matrix<double> m;
	std::vector<double> Row;
	string Line;
	ifstream in("./X.txt"); //up to now, we read txt file
	if( !in ) {
		cerr << "can't open file" << endl;
		//return false;
	}

	// read matrix row's
	int count=0;
	while( getline( in, Line) ) {
		Row = StringToVec<double>( Line );  // read row by row, and put the data into std::vector container
		boost::numeric::ublas::vector<double> d=Convert_vector_to_matrix(Row); // convert vector to matrix, to make the form the same.

		//Row.clear();
		matrix<double> tmp=Convert_vector(d,1);
		// write our own matrix line by line
		if(count==0)
			m=tmp;
		else
			m=bind(m,tmp,2);
		count++;

	}

	return m;
}	







// C<- R'C R, need to be updated each time. used by newJacobi
matrix<double> Updating_C( matrix<double> C, matrix<double> R,boost::numeric::ublas::vector<int> compno){
	matrix<double> M=C;
	matrix<double> C1(2,C.size2());
	row(C1,0)=row(C,compno(0));
	row(C1,1)=row(C,compno(1));


	matrix<double> M1=prod(trans(R),C1);
	row(M,compno(0))=row(M1,0);
	row(M,compno(1))=row(M1,1);

	matrix<double> Cnew=M;

	matrix<double> M2(M.size1(),2);
	column(M2,0)=column(M,compno(0));
	column(M2,1)=column(M,compno(1));

	matrix<double> Cnew1=prod(M2,R);
	column(Cnew,compno(0))=column(Cnew1,0);
	column(Cnew,compno(1))=column(Cnew1,1);

	return Cnew;
}

//Cred=C(compno, compno), used by newJacobi
matrix<double> Get_Cred(matrix<double> C, boost::numeric::ublas::vector<int> compno){
	 matrix<double> Cred_tmp(2,C.size2());
     row(Cred_tmp,0)=row(C,compno(0));
	 row(Cred_tmp,1)=row(C,compno(1));
	 matrix<double> Cred(2,2);
	 column(Cred,0)=column(Cred_tmp,compno(0));
	 column(Cred,1)=column(Cred_tmp,compno(1));
	 return Cred;
}

//function sqrt_m has been declared before

//after getting new C from C=R'CR, we need to update the covariance matrix as well
// the basic algorithm is: C=R'CR=(R'C)R=M*R; where M=R'C
// since R is 2*2 matrix, we only update the rows and coloums that would be affected by R
matrix<double> Updating_cc(matrix<double> Cnew,matrix<double> cc, boost::numeric::ublas::vector<int> compno ){

	 matrix<double> dnew(1,Cnew.size1());
	 for (int i=0; i<Cnew.size1();i++)
		 dnew(0,i)=Cnew(i,i);
	 matrix<double> dnew1(2,1);
	 dnew1(0,0)=dnew(0,compno(0));
	 dnew1(1,0)=dnew(0,compno(1));

	 matrix<double> temp=prod(dnew1,dnew);
	 temp=sqrt_m(temp);

	 matrix<double> tmpnew(2,Cnew.size2());
	 row(tmpnew,0)=row(Cnew,compno(0));
	 row(tmpnew,1)=row(Cnew,compno(1));

	 tmpnew=element_div(tmpnew,temp);

	 matrix<double> ccnew=cc;
	 row(ccnew,compno(0))=row(tmpnew,0);
	 row(ccnew,compno(1))=row(tmpnew,1);

	 tmpnew=trans(tmpnew);
	 column(ccnew,compno(0))=column(tmpnew,0);
	 column(ccnew,compno(1))=column(tmpnew,1);
	 
	 return ccnew;
}

// the function newJacobi has too many outputs. Write it in a structure. Easy to call
struct newJacobi_result {
	newJacobi_result() {}
	matrix<double> Cnew;
	matrix<double> ccnew;
	matrix<double> R;
	boost::numeric::ublas::vector<int> compno;
	boost::numeric::ublas::vector<int> idx;
	double theta;
};

// newJacobi --- Decorrelate group of two components with modified Jacobi's method

// Input:
//  C     input covariance matrix   m-by-m matrix, while m is the number of covariates
//  cc     correlation coeffs   also m-by-m matrix
//  maskno components which are already merged, have to mask them out
// Output:
//   Cnew   updated C, m-by-m matrix
//   ccnew  Updated cc;
//  R        Rotation matrix, 2-by-2
//                  x <- R'x 
//                   C <- R'CR
//   theta           rotation angle

//  compno(1,2)     indices of components that we choose to merge (have highest correlation)
//   idx             [1 2] or [2 1] depending on order of prinicipal comps whichever have the largest eigenvalue would be put the first


newJacobi_result newJacobi(matrix<double> C,matrix<double> cc,boost::numeric::ublas::vector<int> maskno){
	//take the upper_triangle matrix.
	double theta;
	matrix<double> R(2,2);
	boost::numeric::ublas::vector<int> idx(2);
	matrix<double> Cnew;
	matrix<double> ccnew;


	matrix<double> tri=cc;
	for (int i=0; i<cc.size1();i++)
		for (int j=0; j<=i; j++)
			tri(i,j)=-1;// only take the upper triangle matrix
	//maskout all the merged modes;
	boost::numeric::ublas::vector<double> r(cc.size1()); //remember that cc.size1()==cc.size2().
	for (int i=0; i<cc.size1();i++)
		r(i)=-1;

	for (int i=0; i<maskno.size();i++){
		row(tri,maskno[i])=r;
		column(tri,maskno[i])=r;
	}
	//find the maximum, the pair index
	boost::numeric::ublas::vector<int> compno=Get_max(tri);
	// Cred=C(compno,compno) 

	matrix<double> Cred=Get_Cred(C,compno);
	//The original Jacobi algorithm
	if(Cred(0,1)==0){
		R(0,0)=1;
		R(1,1)=1;
		R(0,1)=0;
		R(1,0)=0;
		theta=0;
		idx(0)=1;
		idx(1)=2;
		Cnew=C;
		ccnew=cc;

	}else{
		double C11=Cred(0,0), C22=Cred(1,1), C12=Cred(0,1);
		theta=1.0/2.0*atan(2*C12/(C11-C22));
		double cs=cos(theta);
		double sn=sin(theta);
		//R is the rotation matrix, 2-by-2
		R(0,0)=cs;
		R(1,1)=cs;
		R(0,1)=-sn;
		R(1,0)=sn;

		//update C. C=R'CR

		Cnew=Updating_C(C,R,compno);
		Cred=Get_Cred(Cnew,compno);
		C11=Cred(0,0);
		C22=Cred(1,1);
		C12=Cred(0,1);
		// idx is used to indicate "sum" and "diff". the larger one of the two eigenvalue would be idx(0)


		if(C11<C22){
			idx(0)=1; 
			idx(1)=0;
		}else{
			idx(0)=0;
			idx(1)=1;
		}

		//updating cc

		ccnew=Updating_cc(Cnew,cc,compno);
	}
	//put the result
	newJacobi_result a = newJacobi_result();
	a.ccnew = ccnew;
	a.Cnew = Cnew;
	a.R=R;
	a.compno=compno;
	a.idx=idx;
	a.theta=theta;

	return a;
}

// put all the return result of buildJtree into a structure
struct BuildJTree_result
{
	BuildJTree_result(){}
	matrix<double> Z;
	boost::numeric::ublas::vector<double> theta;
	matrix<int> PCidx;
	std::vector<matrix<double>> T;
    boost::numeric::ublas::vector<int> nodes;
	boost::numeric::ublas::vector<int> dlabels;
	boost::numeric::ublas::vector<double> PC_ratio;
	matrix<int> Zpos;
	matrix<int> all_d;
	matrix<double> C;
	matrix<double> cc;
	matrix<int> all_nodes;
};

// BUILD_JTREE --- Build a hierarchical/wavelet tree of 2-by-2 Jacobi rotations
// Input:
//  C     input covariance matrix   m-by-m matrix, while m is the number of covariates
//  cc     correlation coeffs   also m-by-m matrix
//   maxlevel        The highest triming level of the tree. Here it is m(num of covariates)-1
// Output:
//   Zpos               the indices of the two merged covariates
//   T                  a std::vector container to put the rotation matrix R
//   PCidx              Put on idx, each row put the idx at each lev
//  all_nodes           the current nodes labels, each row put the labels for each level
//   theta               rotation angles 
//   PC_ratio           ratio of the smn to dif
//  Z                 hierarchical cluster tree; columns 1 and 2 contain the indices of clusters that are merged
//   all_d               labels of the d-components in the comp
//   Cnew(dim,dim)       updated covariance matrix 
//    ccnew(dim,dim)      correlation coefficients


BuildJTree_result Build_JTree(matrix<double> C, matrix<double> cc, int maxlevel){
	int dim=C.size1();
	int J=maxlevel;
	matrix<double> Z(J,2);// put the indices that are merged
	//generate(Z.data().begin(),Z.data().end(),zeromat());
	boost::numeric::ublas::vector<double> theta(J);
	matrix<int> PCidx(J,2); // idx
	std::vector<matrix<double>> T(0);// the vector is used to put the rotation matrix at each level

	//initialize
	boost::numeric::ublas::vector<int> maskno(0);
	//nodes must be initialized, from 1:dim (but in C, it is from 0:dim-1)
    boost::numeric::ublas::vector<int> nodes(dim);
	for (int i=0; i<dim; i++)
		nodes(i)=i;
	boost::numeric::ublas::vector<int> dlabels(dim); // difs
	boost::numeric::ublas::vector<double> PC_ratio(dim-1);  
	matrix<int> Zpos(J,2);
	matrix<int> all_d(J,dim);
	matrix<int> all_nodes(J,dim);// all_d and all_nodes just record dlables and nodes at each level


	for (int lev=0; lev<J; lev++){
		newJacobi_result r=newJacobi(C,cc,maskno);
		//updating Z
		Z(lev,0)=nodes(r.compno(0));
		Z(lev,1)=nodes(r.compno(1));
		theta(lev)=r.theta;//updating theta
		row(PCidx,lev)=r.idx;//updating PCidx
		T.push_back(r.R);//T{lev}=R;
		C=r.Cnew;
		cc=r.ccnew; //updating C and cc respectively
		boost::numeric::ublas::vector<int> pind(2);
		pind(0)=r.compno(r.idx(0));
		pind(1)=r.compno(r.idx(1));
		nodes(pind(0))=dim+lev;
		nodes(pind(1))=-1;
		dlabels(pind(1))=lev;
		//updating maskno
		boost::numeric::ublas::vector<int> maskno2(maskno.size()+1);
		for (int i=0; i<maskno.size();i++)
			maskno2[i]=maskno[i];
		maskno2(maskno.size())=pind(1);
		maskno=maskno2;
		//updating PC_ratio
		PC_ratio(lev)=C(pind(1),pind(1))/C(pind(0),pind(0));
		row(Zpos,lev)=r.compno;// updating zpos
		row(all_d,lev)=trans(dlabels);// updating all_d
		row(all_nodes,lev)=nodes;// record nodes
	}
   BuildJTree_result a=BuildJTree_result();
   a.C=C;
   a.all_d=all_d;
   a.cc=cc;
   a.dlabels=dlabels;
   a.nodes=nodes;
   a.PC_ratio=PC_ratio;
   a.PCidx=PCidx;
   a.T=T;
   a.theta=theta;
   a.Z=Z;
   a.all_nodes=all_nodes;
   a.Zpos=Zpos;
   return a;

}















struct JTreeBasis_result
{
	JTreeBasis_result(){}
	matrix<double> sums;
	matrix<double> difs;
	matrix<double> basis;
	
};
// a simple flip function. Like the function flipud in matlab
matrix<double> flip(matrix<double> &d){
	int n=d.size1();
	if(n==1){
	}else{
	int k=(n%2==0)*n/2+(n%2!=0)*(n-1)/2;
	for (int i=0; i<k; i++){
		boost::numeric::ublas::vector<double> x=row(d,i);
		boost::numeric::ublas::vector<double> y=row(d,n-i-1);
		boost::numeric::ublas::vector<double> temp=x;
		x=y;
		y=temp;
		row(d,i)=x;
		row(d,n-i-1)=y;
	}
	}
	return d;
}

// JTree_Basis --- Calculate the basis for the Jacobi tree algorithm (one or more iterations)
// Input:
//   Zpos  
//   T
//   PCidx
//   maxlev  default:dim-1
//   all_nodes
// Output:
//   basis       Basis functions entered ROW-WISE --- coarse-to-fine where m is the dimension of the data
//   sums      Part of basis funcs of subspaces V1,...,V_{m-1}  ---- entered rowwise (fine-to-coarse)
//   difs     Basis funcs of subspaces W1,...,W_{m-1} ---- entered rowwise (fine-to-coarse)
JTreeBasis_result JTree_Basis(matrix<int> Zpos,  std::vector<matrix<double>> T, matrix<int> PCidx, int maxlev,matrix<int> all_nodes){
   int m=all_nodes.size2();
   matrix<double> t(m,m);
   generate(t.data().begin(),t.data().end(),zeromat());
   for(int i=0; i<m; i++)
	   t(i,i)=1;
    matrix<double> tmp_const=t; //tmp is also a diagnal matrix
   matrix<double> sums(maxlev,m);
   //generate(sums.data().begin(),sums.data().end(),zeromat());
   matrix<double> difs(maxlev,m);
   //generate(difs.data().begin(),difs.data().end(),zeromat());
   

   for(int lev=0; lev<maxlev; lev++){
	   matrix<double> s(2,m);  //contains components to be merged
	   // the following function just realize s=t(Zpos(lev,:):);
       boost::numeric::ublas::vector<int> s1(2);
	   s1=row(Zpos,lev);
	   row(s,0)=row(t,s1(0));
	   row(s,1)=row(t,s1(1));
	   matrix<double> R=T[lev];
	   matrix<double> y=prod(trans(R),s);
	   row(t,s1(0))=row(y,0);
	   row(t,s1(1))=row(y,1);
       // sort y, y(1,:)=PC1; y(2,:)=PC2
	   if(PCidx(lev,0)>PCidx(lev,1)){
	   boost::numeric::ublas::vector<double> tmp_y(m);
	   tmp_y=row(y,0);
	   row(y,0)=row(y,1);
	   row(y,1)=tmp_y;
	   }
	   row(sums,lev)=row(y,0);
	   row(difs,lev)=row(y,1);
   }
   
   //Get basis, have not done it yet
   matrix<double> tmp=bind(tmp_const,sums,2);
   //get nodes, needs to be fixed
   boost::numeric::ublas::vector<int> nodes=row(all_nodes,maxlev-1);
   matrix<double> basis(m,m);
   int n=0;   //n records how many nodes currently have
   for (int i=0; i<m; i++){
	   if(nodes(i)>=0){
	   row(basis,n)=row(tmp,nodes(i));
	   n++;
	   }
   }
	   basis= subrange(basis, 0, n,0,m);
	   matrix<double> w=difs;;
	   w=flip(w);
	   basis=bind(basis,w,2); 

   JTreeBasis_result a=JTreeBasis_result();
   a.sums=sums;
   a.difs=difs;
   a.basis=basis;
   return a;
}


// the struct is used for sorting
struct sort_vector {
  bool operator() (double i,double j) { return (i>j);}
} myobject;
//JTree_Scores is actually trying to find the best tree height
//Output:
//Scores, the score of each tree-height
// The algorithm is very similar to JTree_basis


boost::numeric::ublas::vector<double> JTree_Scores(matrix<double> X, int K, matrix<int> Zpos,std::vector<matrix<double>> T,matrix<double> PCidx,int maxlev,matrix<int> all_nodes){
	   int m=all_nodes.size2();
	   int J=Zpos.size1();
	   matrix<double> t(m,m);
	   generate(t.data().begin(),t.data().end(),zeromat());
	   for(int i=0; i<m; i++)
		   t(i,i)=1;
	   matrix<double> tmp_const=t; //tmp_const is also a diagnal matrix
	   matrix<double> sums(maxlev,m);
	   //generate(sums.data().begin(),sums.data().end(),zeromat());
	   matrix<double> difs(maxlev,m);
	   //generate(difs.data().begin(),difs.data().end(),zeromat());
	   boost::numeric::ublas::vector<int> levels(maxlev+1);
	   for(int i=0; i<=maxlev; i++)  //initialize levels
		   levels(i)=i;
	   boost::numeric::ublas::vector<double> scores(maxlev+1);
	   generate(scores.begin(),scores.end(),zeromat());
	   double av_norm=Get_mean(Convert_vector(Get_sum(element_prod(X,X),1),1),1)(0);
	   matrix<double> X1=subrange(X,0,X.size1(),0,K);
	   scores(0)=Get_mean(Convert_vector(Get_sum(element_prod(X1,X1),1),1),1)(0)/av_norm;
	   for(int lev=0; lev<maxlev; lev++){
	   //int lev=0;
		   matrix<double> s(2,m);
		   boost::numeric::ublas::vector<int> s1(2);
		   s1=row(Zpos,lev);
		   row(s,0)=row(t,s1(0));
		   row(s,1)=row(t,s1(1));
		   matrix<double> R=T[lev];
		   matrix<double> y=prod(trans(R),s);
		   row(t,s1(0))=row(y,0);
		   row(t,s1(1))=row(y,1);
		   // sort y, y(1,:)=PC1; y(2,:)=PC2
		   if(PCidx(lev,0)>PCidx(lev,1)){
		   boost::numeric::ublas::vector<double> tmp_y(m);
		   tmp_y=row(y,0);
		   row(y,0)=row(y,1);
		   row(y,1)=tmp_y;
		   }
		   row(sums,lev)=row(y,0);
		   row(difs,lev)=row(y,1);

		   //Get basis, have not done it yet
	   matrix<double> tmp=bind(tmp_const,sums,2);
	   //get nodes, needs to be fixed
	   boost::numeric::ublas::vector<int> nodes=row(all_nodes,lev);
	   matrix<double> basis(m,m);
	   int n=0;   //n records how many nodes currently have
	   for (int i=0; i<m; i++){
		   if(nodes(i)>=0){
		   row(basis,n)=row(tmp,nodes(i));
		   n++;
		   }
	   }
		   basis= subrange(basis, 0, n,0,m);
		   matrix<double> w=subrange(difs,0,(lev+1),0,difs.size2());;
		   w=flip(w);

		   basis=bind(basis,w,2);
		   matrix<double> coeffs=prod(X,trans(basis));
		   matrix<double> energy=element_prod(coeffs,coeffs);
		   boost::numeric::ublas::vector<double> avE=Get_mean(energy,2)/av_norm;
		   sort (avE.begin(), avE.end(), myobject); 
		   //reverse(avE.begin(), avE.end());
		  double sum_avE=0.0;
		   for(int i=0; i<K;i++)
			   sum_avE=sum_avE+avE(i);
		   scores(lev+1)=sum_avE;
	   }

	 return scores;
}

struct ScoreJTree_result
{
	ScoreJTree_result(){}
	boost::numeric::ublas::vector<double> scores;
	int maxlev;
	boost::numeric::ublas::vector<double> theta;
	matrix<int> PCidx;
	std::vector<matrix<double>> T;
	//boost::numeric::ublas::vector<int> levels;
	matrix<int> Zpos;
	matrix<int> all_nodes;
};

	
// fun this function and get the totally result

ScoreJTree_result Score_JTree(matrix<double> Xtrain,matrix<double> Xtest,int K){
	//input is the training and testing matrix, and the best K-basis: K
	matrix<double> cc=Get_cc(Xtrain);
	matrix<double> C=prod(trans(Xtrain),Xtrain)/double(Xtrain.size1());
	int maxlev=Xtrain.size2()-1;
	BuildJTree_result train_result=Build_JTree(C,cc,maxlev);
	boost::numeric::ublas::vector<double> final_score=JTree_Scores(Xtest,K,train_result.Zpos,train_result.T,train_result.PCidx,maxlev,train_result.all_nodes);

	ScoreJTree_result a=ScoreJTree_result();
	a.scores=final_score;
	a.Zpos=train_result.Zpos;
	a.T=train_result.T;
	a.maxlev=maxlev;
	a.all_nodes=train_result.all_nodes;
	a.PCidx=train_result.PCidx;
	a.theta=train_result.theta;
	return a;
}

struct RunJTree_result
{
	RunJTree_result(){}
	boost::numeric::ublas::vector<double> theta;
	matrix<int> PCidx;
	std::vector<matrix<double>> T;
	//boost::numeric::ublas::vector<int> levels;
	matrix<int> Zpos;
	matrix<int> all_nodes;
	matrix<double> C;
	matrix<double> cc;
	matrix<double> all_d;
	matrix<double> sums;
	matrix<double> difs;
	matrix<double> basis;
};

RunJTree_result Run_JTree(matrix<double> X,int maxlev){
	//input is the matrix X and the maxlev
	cout<<"Reading matrix has finished."<<endl;
	matrix<double> cc=Get_cc(X);
	matrix<double> C=prod(trans(X),X)/double(X.size1());
	BuildJTree_result train_result=Build_JTree(C,cc,maxlev);
	JTreeBasis_result final_basis=JTree_Basis(train_result.Zpos,train_result.T,train_result.PCidx,maxlev,train_result.all_nodes);

	RunJTree_result a=RunJTree_result();
	a.Zpos=train_result.Zpos;
	a.T=train_result.T;
	a.all_nodes=train_result.all_nodes;
	a.PCidx=train_result.PCidx;
	a.theta=train_result.theta;
	a.C=train_result.C;
	a.cc=train_result.cc;
	a.sums=final_basis.sums;
	a.difs=final_basis.difs;
	a.basis=final_basis.basis;
	return a;
}